config/routes.rb
require 'api_constraints'
RiseRp::Application.routes.draw do
  
  root 'pages#index'  

  get :search, to: 'resources#search'

  resources :collections do
    collection do 
      get :import
    end
    resources :resources, controller: 'collections/resources' do
      collection do
        get :import
      end
    end
  end

  resources :resources do
    resources :sections, controller: 'resources/sections' do
      collection do
        get :import
      end
    end
  end

  resources :sections, controller: 'resources/sections' do
    resources :content_units, controller: 'sections/content_units' do
      collection do
        get :import
      end
    end
  end

  resources :pages do
    collection do
      get :home
      get :help
    end
  end

  namespace :api, defaults: { format: :json } do
    scope module: :v1, constraints: ApiConstraints.new(version: 1, default: true) do
      get :search, param: :q, to: 'resources#search'
      resources :collections, param: :uuid, only: %i{index show} do
        resources :resources, only: %i{index}, controller: 'collections/resources' do
        end
      end
      resources :resources, param: :uuid, only: %i{index show} do
        member do
          get :metadata
        end
        resources :sections, only: %i{index}, controller: 'resources/sections'
      end
      resources :sections, param: :uuid, only: %i{index show} do
        member do
          get :metadata
        end
        resources :content_units, only: %i{index}, controller: 'sections/content_units' do
        end
      end
      resources :content_units, param: :uuid, only: %i{show} do
        member do
          get :metadata
        end
      end
    end
  end
end

app/models/section.rb
# == Schema Information
#
# Table name: sections
#
#  id          :bigint(8)        not null, primary key
#  resource_id :bigint(8)
#  uuid        :uuid             not null
#  name        :string
#  metadata    :jsonb
#  ancestry    :string
#  is_leaf     :boolean          default(FALSE)
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Section < ApplicationRecord
  include UuidFindable

  has_ancestry

  belongs_to :resource, inverse_of: :sections
  has_many :content_units, inverse_of: :section, dependent: :destroy

  default_scope { order(name: :asc) }

  def content_unit_count
    content_units.count
  end

  def parent_uuid
    if parent.nil?
      nil
    else
      parent.uuid
    end
  end

end

app/controllers/api/v1/resources/sections_controller.rb
module Api
  module V1
    module Resources
      class SectionsController < Api::ApiController
        before_action :set_resource, only: %i{index}
        def index
          render json: @resource.sections
        end

        private

        def set_resource
          @resource = Resource.from_uuid(params[:resource_uuid])
        end
      end
    end
  end
end

app/controllers/api/v1/sections/content_units_controller.rb
module Api
  module V1
    module Sections
      class ContentUnitsController < Api::ApiController
        before_action :set_section, only: %i{index docusky_index}

        def index
          render json: @section.content_units
        end

        private

        def set_section
          @section = Section.from_uuid(params[:section_uuid])
        end
      end
    end
  end
end

app/controllers/api/v1/sections_controller.rb
module Api
  module V1
    class SectionsController < Api::ApiController
      before_action :set_section, only: %i{show metadata}

      def show
        render json: @section
      end

      def metadata
        render json: @section.metadata.to_json
      end

      private

      def render_errors
        render json: { errors: @section.errors }, status: :unprocessable_entity
      end

      def set_section
        @section = Section.from_uuid(params[:uuid])
      end
    end
  end
end

app/controllers/resources/sections_controller.rb
module Resources
  class SectionsController < ApplicationController
    before_action :set_resource, only: %i[index edit update import new create destroy]
    before_action :set_section, only: %i[show edit update destroy]
  
    def index
    	@sections = @resource.sections.page params['page']
    end
  
    def import
    end
  
    def show; end
  
    def new
      @section = Section.new
    end
  
    def edit; end
  
    def create
      @section = @resource.sections.build(section_params)
      if @section.save
        redirect_to [@resource, Section], notice: 'Section was successfully created.'
      else
        render :new
      end
    end
  
    def update
      if @section.update(section_params)
        redirect_to [@resource, :sections], notice: 'Section was successfully updated.'
      else
        render :edit
      end
    end
  
    def destroy
      @section.destroy
      redirect_to [@resource, :sections], notice: 'Section deleted'
    end
  
    def set_resource
      @resource = Resource.find(params[:resource_id])
    end

    def set_section
      @section = Section.find(params[:id])
    end
  
    def section_params
      params.fetch(:section, {}).permit(:name, :resource_id, :parent_id)
    end
  end
end

app/controllers/sections/content_units_controller.rb
module Sections
  class ContentUnitsController < ApplicationController
    before_action :set_section, only: %i[index edit update import new create destroy]
    before_action :set_content_unit, only: %i[show edit update destroy]
  
    def index
    	@content_units = @section.content_units.page params['page']
    end
  
    def import
    end
  
    def show; end
  
    def new
      @content_unit = ContentUnit.new
    end
  
    def edit; end
  
    def create
      @content_unit = @section.content_units.build(content_unit_params)
      if @content_unit.save
        redirect_to [@section, ContentUnit], notice: 'Content Unit was successfully created.'
      else
        render :new
      end
    end
  
    def update
      if @content_unit.update(content_unit_params)
        redirect_to [@section, :content_units], notice: 'Content Unit was successfully updated.'
      else
        render :edit
      end
    end
  
    def destroy
      @content_unit.destroy
      redirect_to [@section, :content_units], notice: 'ContentUnit deleted'
    end
  
    def set_section
      @section = Section.find(params[:section_id])
    end

    def set_content_unit
      @content_unit = ContentUnit.find(params[:id])
    end
  
    def content_unit_params
      params.fetch(:content_unit, {}).permit(:name, :content)
    end
  end
end

app/views/resources/sections/_form.html.haml
= simple_form_for([@resource, @section]) do |f|
  = f.error_notification
  = f.input :name
  = f.input :parent_id, collection: @resource.sections.where.not(id: @section.id) , value_method: :id, as: :select, include_blank: true
  = f.button :button, type: :submit, class: 'btn btn-primary'

app/views/resources/sections/edit.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h2 Edit Section
= render 'form'

app/views/resources/sections/index.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h4 #{link_to truncate(@resource.collection.name, length: 20), [@resource.collection, Resource]} > #{link_to truncate(@resource.name, lenght: 20), [@resource, Section]} > Sections
  .btn-toolbar.mb-2.mb-md-0
    .btn-group.mr-2
      = link_to new_resource_section_path(@resource), class: 'btn btn-sm btn-outline-secondary' do
        %span{"data-feather" => "plus"}
        New Section
      = link_to import_resource_sections_path(@resource), class: 'btn btn-sm btn-outline-secondary' do 
        %span{"data-feather" => "upload"}
        Import Sections
.table-responsive
  %table.table.table-striped.table-sm
    %thead
      %tr
        %th uuid
        %th Name
        %th Parent
        %th Metadata
        %th Content Unit Count
        %th Actions
    %tbody
      - @sections.each do |section|
        %tr
          %td= section.uuid
          %td= section.name
          %td= section.has_parent? ? section.parent.name : 'none'
          %td= section.metadata
          %td= section.content_units.size
          %td
            .btn-group-vertical
              = link_to section_content_units_path(section), class: 'btn btn-sm btn-outline-secondary' do
                %span{"data-feather" => "file-text"}
                Content Units
              = link_to edit_resource_section_path(id: section.id, resource_id: @resource.id), class: 'btn btn-sm btn-outline-secondary' do
                %span{"data-feather" => "edit"}
                Edit
              = link_to resource_section_path(id: section.id, resource_id: @resource.id), method: :delete, class: 'btn btn-sm btn-outline-secondary' do 
                %span{"data-feather" => "x-circle"}
                Delete
= paginate @sections, theme: 'twitter-bootstrap-4'

app/views/resources/sections/new.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h2 New Section for Resource #{@resource.name}
= render 'form'